// Code generated by go-swagger; DO NOT EDIT.

package app_setup

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// NewSSHKeyCreateParams creates a new SSHKeyCreateParams object
// with the default values initialized.
func NewSSHKeyCreateParams() *SSHKeyCreateParams {
	var ()
	return &SSHKeyCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewSSHKeyCreateParamsWithTimeout creates a new SSHKeyCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSSHKeyCreateParamsWithTimeout(timeout time.Duration) *SSHKeyCreateParams {
	var ()
	return &SSHKeyCreateParams{

		timeout: timeout,
	}
}

// NewSSHKeyCreateParamsWithContext creates a new SSHKeyCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewSSHKeyCreateParamsWithContext(ctx context.Context) *SSHKeyCreateParams {
	var ()
	return &SSHKeyCreateParams{

		Context: ctx,
	}
}

// NewSSHKeyCreateParamsWithHTTPClient creates a new SSHKeyCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSSHKeyCreateParamsWithHTTPClient(client *http.Client) *SSHKeyCreateParams {
	var ()
	return &SSHKeyCreateParams{
		HTTPClient: client,
	}
}

/*SSHKeyCreateParams contains all the parameters to send to the API endpoint
for the ssh key create operation typically these are written to a http.Request
*/
type SSHKeyCreateParams struct {

	/*AppSlug
	  App slug

	*/
	AppSlug string
	/*SSHKey
	  SSH key parameters

	*/
	SSHKey *models.V0SSHKeyUploadParams

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the ssh key create params
func (o *SSHKeyCreateParams) WithTimeout(timeout time.Duration) *SSHKeyCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ssh key create params
func (o *SSHKeyCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ssh key create params
func (o *SSHKeyCreateParams) WithContext(ctx context.Context) *SSHKeyCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ssh key create params
func (o *SSHKeyCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ssh key create params
func (o *SSHKeyCreateParams) WithHTTPClient(client *http.Client) *SSHKeyCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ssh key create params
func (o *SSHKeyCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppSlug adds the appSlug to the ssh key create params
func (o *SSHKeyCreateParams) WithAppSlug(appSlug string) *SSHKeyCreateParams {
	o.SetAppSlug(appSlug)
	return o
}

// SetAppSlug adds the appSlug to the ssh key create params
func (o *SSHKeyCreateParams) SetAppSlug(appSlug string) {
	o.AppSlug = appSlug
}

// WithSSHKey adds the sSHKey to the ssh key create params
func (o *SSHKeyCreateParams) WithSSHKey(sSHKey *models.V0SSHKeyUploadParams) *SSHKeyCreateParams {
	o.SetSSHKey(sSHKey)
	return o
}

// SetSSHKey adds the sshKey to the ssh key create params
func (o *SSHKeyCreateParams) SetSSHKey(sSHKey *models.V0SSHKeyUploadParams) {
	o.SSHKey = sSHKey
}

// WriteToRequest writes these params to a swagger request
func (o *SSHKeyCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app-slug
	if err := r.SetPathParam("app-slug", o.AppSlug); err != nil {
		return err
	}

	if o.SSHKey != nil {
		if err := r.SetBodyParam(o.SSHKey); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
